import cStringIO, traceback, os, sys, socket

if hasattr(sys, 'debugger_control') and hasattr(sys, 'breakpoint'):
    sys.boaDebug = 1
else:
    sys.boaDebug = 0
    
def SendMail(subject, message):
    pass

def SendSMS(message):
    pass

# cmp function for floating values trimming any decimals after number of numDecimals
def floatCmp(val1, val2, numDecimals = 4):
    '''Returns negative, zero or positive value
    <0 : val1 < val2
    ==0 : val1 == val2 (within the tolerance specified by numDecimals)
    >0 : val1 > val2'''
    
    diff = ((val1-val2) * 10**numDecimals)
    if diff < -1: return -1
    if diff > 1: return 1
    return 0

#traceback mixins
def GetTraceback():
    sio = cStringIO.StringIO()
    traceback.print_exc(file=sio)
    sio.seek(0)
    return sio.read()
traceback.get_traceback = GetTraceback

#os mixins
def RemoveFiles(dirName):
    map(os.remove,
        [dirName+"\\"+fileName
         for fileName in os.listdir(dirName,1)])

def ListDir(dirName, onlyFiles=0):
    return [fileName
            for fileName in os.listdirall(dirName)
            if not onlyFiles or (onlyFiles and os.path.isfile(dirName+"\\"+fileName))]
    
    
COINIT_MULTITHREADED = 0
COINIT_APARTMENTTHREADED = 2
        
def CoInitThread(threadingModel = COINIT_MULTITHREADED):
    '''Initialise thread with COM
    threadingModel : COINIT_MULTITHREADED by default, COINIT_APARTMENTTHREADED also provided.'''
    #check if pythoncom module was imported
    if not sys.modules.has_key('pythoncom'):
        sys.co_initflags = threadingModel
        import pythoncom
    else:
        pythoncom = sys.modules['pythoncom']
    pythoncom.CoInitializeEx(threadingModel)

def getNextOpenSocket(port, tryLimit = 25):
    '''Gets the next open socket, starting at port.
    The open port is "reserved" by binding a socket object to it.
    This socket object is returned by this function.
    Use the socked object as follows:
        to get the port                            : socketObject.port
        to release the port so that it can be used : socketObject.close()'''
    valid = 0
    tries = 0
    while not valid:
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        try:
            print "Trying %s" %port
            s.bind(('',port))
            valid = 1
            s.port = port
        except:
            s.close()
            port += 1
            tries += 1
            if tries > tryLimit:
                raise
    return s

def getMachineName():
    return socket.gethostbyaddr('')[0]

def getMachineIp():
    return socket.gethostbyaddr('')[2]    

def formatStackItem(stackPos = -2):
    '''Returns where you are in the form moduleName:functionName'''
    stackItem = traceback.extract_stack()[stackPos]
    fileName, lineNo, funcName, lineCode = stackItem
    moduleName = os.path.splitext(os.path.split(fileName)[-1])[0]
    return '%s:%s' %(moduleName, funcName)

def IntToBinary(val,bits=32):
    o = ''
    for i in range(bits):
        c = (2**i & val) and "1" or "0"
        o = c + o
    return o
        
    
        
os.removefiles = RemoveFiles

#XXX giving me grief when used in a Zope product :(
##if not hasattr(os,'listDirChanged'):
##    os.listdirall = os.listdir
##    os.listdir = ListDir
##    os.listDirChanged = 1
