#This client subscribes to Topic1 and publishes what it receives into Topic2
import xmlrpclib, time,sys, cStringIO, traceback

#handy method to get tracebacks
def GetTraceback():
    sio = cStringIO.StringIO()
    traceback.print_exc(file=sio)
    sio.seek(0)
    return sio.read()

try:
    serverAddress = sys.argv[1] #get the server address from the first command line arg
except IndexError:
    serverAddress = "http://localhost:8080/ZQueueNode" #if no server address, use this hard-coded one
    
print "Connecting to server at: %s" %serverAddress
    
node = xmlrpclib.Server(serverAddress) #XML-RPC proxy to node

while 1:
    try:
        #subscribing only need to be done once, only reason we do it every time is so 
        #we can totally reset the node for testing
        node.subscribeToTopic('Topic1','EchoClient')
        
        #read the messages from Topic1 - identify ourselves as EchoClient
        messages = node.readMessagesFromTopic('Topic1','EchoClient')
        messageIds = []
        messageBodies = []
        #work through the messages received - build up a list of message ids that will be used
        #to ack the server
        for messageId, message in messages:
            messageIds.append(messageId)
            if len(message)>200:
                print "Large Message received (%s chars):\n\t%s..." %(len(message), message[0:60])
            else:
                print "Message received: %s" %message
            #publish the received message to Topic2
            node.publishMessageToTopic('Topic2',message)
        #ack the received messages so the server know we received them and don't need them anymore
        node.ackMessagesFromTopic('Topic1','EchoClient',messageIds)
        #sleep for 10 secs
        time.sleep(10)
    except:
        #we never want to crash the echo client, so swallow all exceptions
        print "Error in server poll cycle:"
        #at least print out the traceback!
        print GetTraceback()
        time.sleep(10)
            

        
        
    
    