#This client creates messages for Topic1 it then looks for
#This cleint subscribes to Topic2 and prints out what it has received.

import xmlrpclib, time, sys, cStringIO, traceback

#handy method to get tracebacks
def GetTraceback():
    sio = cStringIO.StringIO()
    traceback.print_exc(file=sio)
    sio.seek(0)
    return sio.read()

try:
    numberOfMessages = int(sys.argv[1]) #number of messages to generate each cycle as first command line arg
except IndexError:
    numberOfMessages = 10 # none give, use 10 messages
    
try:
    timeBetweenSends = float(sys.argv[2]) #time between each send cycle
except IndexError:
    timeBetweenSends = 10 #use 10 secs as the default

try:
    serverAddress = sys.argv[3] #server address as the third command line arg
except IndexError:
    serverAddress = "http://localhost:8080/ZQueueNode" #use this as default
    
    
print "Connecting to server at: %s" %serverAddress
print "Time Between sends: %s" %timeBetweenSends
print "Number of messages: %s" %numberOfMessages
    
node = xmlrpclib.Server(serverAddress) #XML-RPC proxy to node object

sentCounter = 0
receivedCounter = 0

while 1:
    try:
        #subscribing only need to be done once, only reason we do it every time is so 
        #we can totally reset the node for testing
        node.subscribeToTopic('Topic2','GeneratorReceiver')
        #get messages on Topic2 which have been echoed back by the echo client
        messages = node.readMessagesFromTopic('Topic2','GeneratorReceiver')
        messageIds = []
        messageBodies = []
        # print the messages received back and build an ack list at the same time
        for messageId, message in messages:
            messageIds.append(messageId)
            if len(message)>200:
                print "%s : Large Message received (%s chars):\n\t%s..." %(receivedCounter, len(message), message[0:60])
            else:
                print "%s Message received: %s" %(receivedCounter, message)
            receivedCounter += 1
        #ack the messages received from Topic2
        node.ackMessagesFromTopic('Topic2','GeneratorReceiver',messageIds)
        
        #publish a few messages to Topic1
        for i in range(numberOfMessages):
            message = "Message %s in batch, %s total" %(i, sentCounter)
            node.publishMessageToTopic('Topic1',message)
            sentCounter += 1
        print "Messages sent = %s" %sentCounter
        
        #sleep for timeBetweenSends seconds
        time.sleep(timeBetweenSends)
    except:
        #swallow all exceptions so the generator never crashes
        print "Error in server poll cycle:"
        #at least print out the traceback that caused the exception!
        print GetTraceback()
        time.sleep(timeBetweenSends)
            

        
        
    
    