from SimpleXMLRPCServer import *
from time import asctime, sleep

class QueueHandler(SimpleXMLRPCRequestHandler):
    def _dispatch(self, method, params):
        try:
            print dir(self)
            self.server.run_count += 1
            sleep(0.001)
            func = getattr(self, 'exp_' + method)
        except AttributeError:
            raise Exception('method "%s" is not supported' % method)
        else:
            return apply(func, params)
    
    def __del__(self):
        self.server.run_count -= 1
        #SimpleXMLRPCRequestHandler.__del__(self)
    
    def log_message(self, format, *args):
        pass

    def exp_ListOfServices(self):
        result = []
        for item in dir(self):
            if item[:4] == 'exp_':
                result+=[item[4:]]
        return result

class QueueXMLRPCServer(SimpleXMLRPCServer):
    def __init__(self, parent, requestHandler, logRequest = 1):
        SimpleXMLRPCServer.__init__(self, requestHandler, logRequest)
        self.__parent = parent
        self.__serving = 0
        self.run_count = 0
    def run(self):
        self.__serving = 1
        self.running()
        while self.__serving:
            self.handle_request()
    def stop(self):
        self.socket.setblocking(0)
        self.__serving = 0
        maxWaits = 5
        while self.run_count:
            print 'Waiting for all requests to finish'
            sleep(0.5)
            if not maxWaits:
                break
            maxWaits -= 1
        self.stopped()
    def isServing(self):
        return self.__serving
    def running(self):
        print 'QueueXMLRPCServer running...', asctime()
    def stopped(self):
        print 'QueueXMLRPCServer stopped...', asctime()
    def parent(self):
        return self.__parent



#server = QueueXMLRPCServer(None, ("127.0.0.1", 8000), QueueHandler)
#thread.start_new(server.run, ())
#server.stop()
 